



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>ASP.NET没有魔法——ASP.NET MVC 与数据库之Entity Framework Migrations</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">ASP.NET没有魔法——ASP.NET MVC 与数据库之Entity Framework Migrations</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-31 17:45:13 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>　　在开发数据库应用程序的时候，经常会遇到某些表需要添加字段或者修改类型、新增表等需求，而对于EF Code First来说关注的只有实体类，当需求变更时只需要添加新的实体类或者在实体类中添加、删除、修改属性即可。但是修改完成之后要如何将修改同步到数据库中？</p>
<p>　　Entity Framework提供了Migrations机制来解决这一问题。</p>
<h2>启用Migrations</h2>
<p>　　在VS中的Package Manager Console窗口中选择默认项目为DbContext存在的项目，并执行命令：<br />　　<strong>enable-migrations</strong></p>
<p>　　<img referrerpolicy="no-referrer"src="http://images2017.cnblogs.com/blog/640251/201710/640251-20171012152018793-66029828.png" /></p>
<p>　　然后项目中将生成Migrations目录和Configuration类型：</p>
<p>　　<img referrerpolicy="no-referrer"src="http://images2017.cnblogs.com/blog/640251/201710/640251-20171012152248809-1790339120.png" /></p>
<p>　　<img referrerpolicy="no-referrer"src="http://images2017.cnblogs.com/blog/640251/201710/640251-20171012152310277-1529452832.png" /></p>
<p>　　构造方法：用于对一些Migrations相关的配置，如上代码就是禁用了自动迁移。<br />　　Seed方法：根据注释可知在迁移后执行，一般用来添加默认数据。Configuration类型可以根据需求进行修改。</p>
<p>　　注：如过出现以下错误，可把命名空间删除修复：</p>
<p>　　<img referrerpolicy="no-referrer"src="http://images2017.cnblogs.com/blog/640251/201710/640251-20171012152548980-1470535208.png" /></p>
<h2>通过Add-Migration添加Migration</h2>
<p>　　如果已经存在数据库那么需要使用&ndash;IgnoreChanges参数来创建一个空的Migration来对应当前的数据库模型：<br />　　<strong>Add-Migration InitialCreate &ndash;IgnoreChanges</strong></p>
<p>　　<img referrerpolicy="no-referrer"src="http://images2017.cnblogs.com/blog/640251/201710/640251-20171012153529621-1135465187.png" /></p>
<p>　　这时在Migrations目录下会生成一个带时间戳的InitialCreate.cs文件：</p>
<p>　　<img referrerpolicy="no-referrer"src="http://images2017.cnblogs.com/blog/640251/201710/640251-20171012154010324-1841817914.png" /></p>
<p>　　注：上面的代码的Up和Down方法之所以为空是因为使用了&ndash;IgnoreChanges参数，因为数据库中已经有对应的表和字段，所以不应该再创建一次，如果去掉该参数会生成以下代码：</p>
<p>　　<img referrerpolicy="no-referrer"src="http://images2017.cnblogs.com/blog/640251/201710/640251-20171012162441434-1854529303.png" /></p>
<h2>Update-Database更新数据库</h2>
<p>　　执行Update-Database目录来更新数据库：<br />　　<strong>update-database -StartUpProjectName 'My Blog' -ProjectName BlogRepository.MySQL</strong> <br />　　注：由于本例的DbContext相关类型在BlogRepository.MySQL中，但是连接字符串在My Blog项目中，所以在执行数据库更新时需要指定启动项目和项目名称两个参数。一般情况下使用update-database命令即可。</p>
<p>　　<img referrerpolicy="no-referrer"src="http://images2017.cnblogs.com/blog/640251/201710/640251-20171012154616074-1151218046.png" /></p>
<p>　　这时数据库中多了一个名称为__MigrationsHistory表并有一条记录。</p>
<p>　　<img referrerpolicy="no-referrer"src="http://images2017.cnblogs.com/blog/640251/201710/640251-20171012154644605-454133471.png" /></p>
<h2>更新模型并添加新的Migration</h2>
<p>　　1. 为模型添加一个新的属性"IsPublish"来代表文章是否被公开：</p>
<p>　　<img referrerpolicy="no-referrer"src="http://images2017.cnblogs.com/blog/640251/201710/640251-20171012154751324-914284958.png" />　</p>
<p>　　2. 运行Add-Migration命令，名称最好与变更相关用于区分多个Migration便于维护：<br />　　<strong>add-migration addIsPublishColumn</strong></p>
<p>　　<img referrerpolicy="no-referrer"src="http://images2017.cnblogs.com/blog/640251/201710/640251-20171012154855637-1194737948.png" /></p>
<p>　　执行命令后会生成一个DbMigration的子类，该类型中包含一个Up和Down方法，分别对应更新时和回退时对数据库的操作：</p>
<p>　　<img referrerpolicy="no-referrer"src="http://images2017.cnblogs.com/blog/640251/201710/640251-20171012155004105-435506342.png" /></p>
<p>　　上面的Up方法就是为dbo.Posts表添加名为"IsPublish"的列，如果回滚这个Migration时则把该列删除。</p>
<p>　　3.&nbsp;再次使用update-database命令将新的变更同步到数据库中：</p>
<p>　　<strong>update-database -StartUpProjectName 'My Blog' -ProjectName BlogRepository.MySQL -Verbose</strong></p>
<p>　　<img referrerpolicy="no-referrer"src="http://images2017.cnblogs.com/blog/640251/201710/640251-20171012155311996-607325666.png" /></p>
<p>　　注：使用参数-Verbose可以看到更多执行信息，包括执行的SQL语句。</p>
<h2>启动应用时自动将数据库更新至最新</h2>
<p>　　启动应用时将数据库更新至最新可以省略&ldquo;update-database&rdquo;命令执行这一过程，只需要添加了Migration，并且该Migration没有同步到数据库，那么在应用执行(实际上是DbContext在创建模型时OnModelCreating)将会把修改同步到数据库。</p>
<p>　　1. 添加ClickCount属性：</p>
<p>　　<img referrerpolicy="no-referrer"src="http://images2017.cnblogs.com/blog/640251/201710/640251-20171012155554527-1036349383.png" /></p>
<p>　　2. 在DBContext类型中添加OnModelCreating方法及代码(注：该操作也可以通过配置文件配置)：</p>
<p>　　<img referrerpolicy="no-referrer"src="http://images2017.cnblogs.com/blog/640251/201710/640251-20171012155632246-206743845.png" /></p>
<p>　　3. 运行程序：</p>
<p>　　<img referrerpolicy="no-referrer"src="http://images2017.cnblogs.com/blog/640251/201710/640251-20171012155739902-1949318661.png" /></p>
<p>　　4. 查看结果：</p>
<p>　　<img referrerpolicy="no-referrer"src="http://images2017.cnblogs.com/blog/640251/201710/640251-20171012160127777-690322567.png" /></p>
<h2>关于Automatic Migrations(自动迁移)</h2>
<p>　　自动迁移指的是在执行&ldquo;update-database&rdquo;命令时，将对比实体模型与数据库结构，如果它们有差异则以实体模型为准，将差异同步到数据库。相当于省略了add-migration命令。</p>
<p>　　在执行启动迁移命令(enable-migrations )时，可以添加参数&ndash;EnableAutomaticMigrations或者在生成待Configuration类型的构造方法中将AutomaticMigrationsEnabled的值设为true。</p>
<p>　　<img referrerpolicy="no-referrer"src="http://images2017.cnblogs.com/blog/640251/201710/640251-20171012160313996-616348874.png" /></p>
<p>　　自动更新数据库(migrate database to latest version)与自动迁移(automatic migrations)，前者省略&ldquo;update-database&rdquo;后者省略&ldquo;add-migration&rdquo;，如果一起使用则两者都省略，开发者仅需通过enable-migrations命令开启迁移，然后在开发中修改完成实体类，就可以调试程序，调试程序过程中自动更新数据库结构。</p>
<p>　　</p>
<p>小结：<br />　　本章主要是介绍EF的迁移功能，对于EF来说这是一个非常重要的功能，因为在开发过程中特别是code first开发过程中，经常会添加实体、修改实体属性甚至会在使用Fluent API来映射数据库关系的时候也会针对某些属性进行修改，如字段类型、最大长度以及索引等。</p>
<p>　　对于自动更新数据库以及自动迁移功能，个人不建议在团队开发正式项目时使用，因为使用Add-Migration命令可以很好的追踪数据库结构的更新，并且可以根据情况进行回滚。而自动更新数据库会导致数据库结构改变，团队工作中如果多人使用了同一个数据库并且在代码未同步时会导致错误的出现。<br />　　但启用自动迁移并且设置数据库初始化时自动将数据库更新至最新将节省很多操作。各有利弊可根据情况选择。</p>
<p>参考：</p>
<p>　　<a href="https://msdn.microsoft.com/en-us/library/jj591621(v=vs.113).aspx" rel="external nofollow noreferrer">https://msdn.microsoft.com/en-us/library/jj591621(v=vs.113).aspx</a></p>
<p>本文连接：<a href="http://www.cnblogs.com/selimsong/p/7656648.html" rel="external nofollow noreferrer">http://www.cnblogs.com/selimsong/p/7656648.html</a></p>
<p><em><a href="http://www.cnblogs.com/selimsong/p/7641799.html" rel="external nofollow noreferrer">ASP.NET没有魔法&mdash;&mdash;目录</a></em></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2x5vv9.html">BerkeleyDB库简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/495jrd0q.html">php set&lowbar;time&lowbar;limit&lpar;&rpar;用法测试详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pgz1d9.html">Unity3d利用opencv保存游戏视频</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2gn138.html">&bsol;&lpar;&bsol;S1&bsol;&rpar; 描述性统计</a>
		</li>
						<li><a href="https://www.batexi.com/a/495vglvq.html">thinkphp伪静态（url重写）</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv41pzq.html">MySQL如何查询两个日期之间的记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p1vx79.html">C&sol;C&plus;&plus;的编译器&vert;编译环境（非常全面的比较）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mx241q.html">Spring&plus;Mybatis&plus;jQuery&period;Pagination&period;js异步分页及JsonConfig的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j06dneq.html">java的真相</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y1d35q.html">input标签上传图片怎么获取src；</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydej2xq.html">iOS面试题04-runtime</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z155mv9.html">MFC自绘控件学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/9500mze8.html">【原创】leetCodeOj --- Copy List with Random Pointer 解题报告</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yp5xg8.html">调用短信接口&comma;先var&lowbar;dump&lpar;&rpar;看数据类型是object需要json&lowbar;decode&lpar;json&lowbar;encode&lpar; &dollar;resp&rpar;&comma;true&rpar;转换成array</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljwmw09.html">介绍maven构建的生命周期</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjzv7j8.html">&lbrack;转&rsqb;高级SQL注入：混淆和绕过</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zonvwxq.html">Android官方技术文档翻译&mdash;&mdash;新构建系统概述</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z5nlk9.html">我手写的简易tomcat</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z412k9.html">Stm32 GPIO复习</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1jdexq.html">TinkPHP框架学习-03模型类</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8oj3v01q.html">Docker 入门实践</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy16r4gq.html">Mock Server 入门</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljw5009.html">iOS蓝牙交互（4&period;0）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjgwv38.html">MVC 常用扩展点：过滤器、模型绑定等</a>
			</li>
						<li><a href="https://www.batexi.com/a/8meykwoq.html">mac环境下安装mysql</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pldvy8.html">201521123084 《Java程序设计》第11周学习总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpgxyzq.html">201521123063 《Java程序设计》 第14周学习总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjgky38.html">Java：print、printf、println的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/950zlpz8.html">java类成员变量与代码块初始化</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m40ln8.html">&lbrack;06&rsqb; Java的数据类型</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
